commit 6f268ee4c14cdde79b29809ef25179fb6b60689b
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Tue Jan 20 18:48:15 2026 +0000

    Debug: ensure extanded channels propagated
    
    Broken-by: bdb65dd6fd1a

diff --git a/src/src/child.c b/src/src/child.c
index 359b791e8..05f87d856 100644
--- a/src/src/child.c
+++ b/src/src/child.c
@@ -107,7 +107,7 @@ if (!minimal)
     {
     if (debug_selector != 0)
       {
-      argv[n++] = string_sprintf("-d=0x%x", debug_selector);
+      argv[n++] = string_sprintf("-d=0x%lx", debug_selector);
       if (debug_fd > 2)
 	{
 	int flags = fcntl(debug_fd, F_GETFD);
diff --git a/src/src/daemon.c b/src/src/daemon.c
index a37cc7cc6..607913f6c 100644
--- a/src/src/daemon.c
+++ b/src/src/daemon.c
@@ -365,9 +365,8 @@ if (pid == 0)
   {
   int queue_only_reason = 0;
   int old_pool = store_pool;
-  int save_debug_selector = debug_selector;
-  BOOL local_queue_only;
-  BOOL session_local_queue_only;
+  unsigned long save_debug_selector = debug_selector;
+  BOOL local_queue_only,  session_local_queue_only;
 #ifdef SA_NOCLDWAIT
   struct sigaction act;
 #endif
diff --git a/src/src/environment.c b/src/src/environment.c
index 9cbd352ec..4b8041f9f 100644
--- a/src/src/environment.c
+++ b/src/src/environment.c
@@ -42,7 +42,7 @@ if (!keep_environment || !*keep_environment)
 else if (Ustrcmp(keep_environment, "*") != 0)
   {
   rmark reset_point = store_mark();
-  unsigned deb = debug_selector;
+  unsigned long deb = debug_selector;
   BOOL hc = host_checking;
   debug_selector = 0;			/* quieten this clearout */
   host_checking = FALSE;
diff --git a/src/src/exim.c b/src/src/exim.c
index e11250cc0..6924b4b14 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -4464,10 +4464,10 @@ a debugging feature for finding out what arguments certain MUAs actually use.
 Don't attempt it if logging is disabled, or if listing variables or if
 verifying/testing addresses or expansions. */
 
-if (  (debug_selector & D_any  ||  LOGGING(arguments))
+if (  (IS_DEBUG(D_any)  ||  LOGGING(arguments))
    && f.really_exim && !list_options && !checking)
   {
-  uschar *p = big_buffer;
+  uschar * p = big_buffer;
   Ustrcpy(p, US"cwd= (failed)");
 
   if (!initial_cwd)
diff --git a/src/src/rewrite.c b/src/src/rewrite.c
index 97c811f41..cf65fc242 100644
--- a/src/src/rewrite.c
+++ b/src/src/rewrite.c
@@ -241,7 +241,7 @@ for (rewrite_rule * rule = rewrite_rules;
 
   /* We have a validly rewritten address */
 
-  if (LOGGING(address_rewrite) || debug_selector & D_rewrite)
+  if (LOGGING(address_rewrite) || IS_DEBUG(D_rewrite))
     {
     const uschar * where = CUS"?";
 
diff --git a/src/src/spool_in.c b/src/src/spool_in.c
index 2dde341f0..35fa5089b 100644
--- a/src/src/spool_in.c
+++ b/src/src/spool_in.c
@@ -620,7 +620,7 @@ for (;;)
       dsn_envid = string_copy_taint(var + 10, proto_mem);
 #ifndef COMPILE_UTILITY
     else if (Ustrncmp(p, "ebug_selector ", 14) == 0)
-      debug_selector = strtol(CS var + 15, NULL, 0);
+      debug_selector = strtoul(CS var + 15, NULL, 0);
     else if (Ustrncmp(p, "ebuglog_name ", 13) == 0)
       debug_logging_from_spool(var + 14);
 #endif
diff --git a/src/src/spool_out.c b/src/src/spool_out.c
index 91b776df2..243db106d 100644
--- a/src/src/spool_out.c
+++ b/src/src/spool_out.c
@@ -232,7 +232,7 @@ tree_walk(acl_var_m, &acl_var_write, fp);
 
 if (*debuglog_name)
   {
-  fprintf(fp, "-debug_selector 0x%x\n", debug_selector);
+  fprintf(fp, "-debug_selector 0x%lx\n", debug_selector);
   fprintf(fp, "-debuglog_name %s\n", debuglog_name);
   }
 

